Correlation Class Reference

`#include <Correlation.h>`

Inheritance diagram for Correlation:

## Public Member Functions

| Correlation (ApplicationWindow *parent, Table *t, const QString &colName1, const QString &colName2, int startRow=1, int endRow=-1)
bool | setDataFromTable (Table *t, const QString &colName1, const QString &colName2, int startRow=1, int endRow=-1)
Public Member Functions inherited from Filter
int | dataSize ()
| Returns the size of the input data set. More...
virtual void | enableGraphicsDisplay (bool on=true, Graph *g=0)
bool | error ()
| Filter (ApplicationWindow *parent, Table *t=0, const QString &name=QString())
| Filter (ApplicationWindow *parent, Graph *g=0, const QString &name=QString())
| Filter (ApplicationWindow *parent, Matrix *m, const QString &name=QString())
| Filter (ApplicationWindow *parent, QwtPlotCurve *c)
virtual QString | legendInfo ()
| Output string added to the plot as a new legend. More...
Graph * | outputGraph ()
| Returns a pointer to the graph where the result curve should be displayed. More...
QwtPlotCurve * | resultCurve ()
| Returns a pointer to the plot curve created to display the results. More...
Table * | resultTable ()
| Returns a pointer to the table created to display the results. More...
virtual bool | run ()
| Actually does the job. Should be reimplemented in derived classes. More...
void | setColor (int colorId)
| Obsolete: sets the color of the output fit curve. More...
void | setColor (const QColor &color)
| Sets the color of the output fit curve. More...
void | setColor (const QString &colorName)
| Sets the color of the output fit curve. Provided for convenience. To be used in scripts only! More...
virtual void | setDataCurve (QwtPlotCurve *curve, double start, double end)
bool | setDataFromCurve (QwtPlotCurve *c)
bool | setDataFromCurve (QwtPlotCurve *c, double from, double to)
bool | setDataFromCurve (const QString &curveTitle, Graph *g=0)
bool | setDataFromCurve (const QString &curveTitle, double from, double to, Graph *g=0)
virtual bool | setDataFromTable (Table *, const QString &, const QString &, int=1, int=-1, bool=false)
void | setError (bool on=true)
void | setInterval (double from, double to)
| Changes the data range if the source curve was already assigned. Provided for convenience. More...
void | setMaximumIterations (int iter)
| Sets the maximum number of iterations to be performed during an iterative session. More...
void | setOutputPoints (int points)
| Sets the number of points in the output curve. More...
void | setOutputPrecision (int digits)
| Sets the precision used for the output. More...
void | setSortData (bool on=true)
void | setTolerance (double eps)
| Sets the tolerance used by the GSL routines. More...
void | setUpdateOutputGraph (bool update=true)
virtual void | showLegend ()
| Adds a new legend to the plot. Calls virtual legendInfo() More...
double * | x ()
| Returns the x values of the input data set. More...
double * | y ()
| Returns the y values of the input data set. More...
| ~Filter ()

## Protected Member Functions

void | addResultCurve ()
| Handles the graphical output. More...
Protected Member Functions inherited from Filter
QwtPlotCurve * | addResultCurve (double *x, double *y)
| Adds the result curve to the target output plot window. Creates a hidden table and frees the input data from memory. More...
virtual void | calculateOutputData (double *X, double *Y)
| Calculates the data for the output curve and store it in the X an Y vectors. More...
MultiLayer * | createOutputGraph ()
virtual int | curveData (QwtPlotCurve *c, double start, double end, double **x, double **y)
int | curveIndex (const QString &curveTitle, Graph *g)
| Performs checks and returns the index of the source data curve if OK, -1 otherwise. More...
int | curveRange (QwtPlotCurve *c, double start, double end, int *iStart, int *iEnd)
virtual void | freeMemory ()
| Frees the memory allocated for the X and Y data sets. More...
void | init ()
virtual QString | logInfo ()
| Output string added to the log pannel of the application. More...
void | memoryErrorMessage ()
virtual int | sortedCurveData (QwtPlotCurve *c, double start, double end, double **x, double **y)
| Same as curveData, but sorts the points by their x value. More...

## Private Member Functions

virtual void | output ()
| Performs the data analysis and takes care of the output. More...

## Additional Inherited Members

Protected Attributes inherited from Filter
QwtPlotCurve * | d_curve
| The curve to be analysed. More...
QColor | d_curveColor
| Color index of the result curve. More...
QString | d_explanation
| String explaining the operation in the comment of the result table and in the project explorer. More...
double | d_from
| Data interval. More...
Graph * | d_graph
| The source graph with the curve to be analyzed. More...
bool | d_graphics_display
| Specifies if the filter should display a result curve. More...
bool | d_init_err
| Error flag telling if something went wrong during the initialization phase. More...
Matrix * | d_matrix
int | d_max_iterations
| Maximum number of iterations per fit. More...
int | d_min_points
| Minimum number of data points necessary to perform the operation. More...
int | d_n
| Size of the data arrays. More...
Graph * | d_output_graph
| The graph where the result curve should be displayed. More...
int | d_points
| Number of result points to de calculated and displayed in the output curve. More...
int | d_prec
| Precision (number of significant digits) used for the results output. More...
QwtPlotCurve * | d_result_curve
| The resulting curve. More...
Table * | d_result_table
| The table displaying the results of the filtering operation (not alvays valid!) More...
bool | d_sort_data
| Specifies if the filter needs sorted data as input. More...
Table * | d_table
| A table source of data. More...
double | d_to
double | d_tolerance
| GSL Tolerance, if ever needed... More...
bool | d_update_output_graph
| Specifies if the filter should update the output graph. More...
double * | d_x
| x data set to be analysed More...
double * | d_y
| y data set to be analysed More...
QString | d_y_col_name

## Constructor & Destructor Documentation

Correlation::Correlation | ( | ApplicationWindow * | parent,
|  | Table * | t,
|  | const QString & | colName1,
|  | const QString & | colName2,
|  | int | startRow = `1`,
|  | int | endRow = `-1`
| ) |  |

References setDataFromTable().

## Member Function Documentation

void Correlation::addResultCurve | ( |  | ) |

protected

Handles the graphical output.

References Table::addCol(), Table::colName(), Table::colNames(), Filter::createOutputGraph(), Filter::d_curveColor, ApplicationWindow::d_decimal_digits, Filter::d_graphics_display, Filter::d_n, Filter::d_output_graph, Filter::d_table, Filter::d_x, Graph::insertPlotItem(), Graph::Line, Table::numCols(), Table::numRows(), Table::setColName(), Table::setColPlotDesignation(), Table::setHeaderColType(), Table::setNumRows(), Table::setText(), Graph::updatePlot(), Table::X, Filter::x(), and Filter::y().

Referenced by output().

void Correlation::output | ( |  | ) |

private virtual

Performs the data analysis and takes care of the output.

Reimplemented from Filter.

References addResultCurve(), Filter::d_n, Filter::d_result_table, Filter::d_table, Filter::d_x, and Filter::d_y.

bool Correlation::setDataFromTable | ( | Table * | t,
|  | const QString & | colName1,
|  | const QString & | colName2,
|  | int | startRow = `1`,
|  | int | endRow = `-1`
| ) |  |

References Table::cell(), Table::colIndex(), Filter::d_init_err, Filter::d_n, Filter::d_table, Filter::d_x, Filter::d_y, Filter::freeMemory(), Filter::memoryErrorMessage(), and Table::numRows().

Referenced by Correlation().

The documentation for this class was generated from the following files:

- qtiplot/src/analysis/Correlation.h
- qtiplot/src/analysis/Correlation.cpp